/*	Main.cpp	*/

#include "ImageManipAddon.h"

#include <Application.h>
#include <Window.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <Alert.h>
#include <stdlib.h>
#include <stdio.h>
#include <OS.h>


extern void SavePrefs();


class ConfigApp : public BApplication
{
public:
	ConfigApp() : BApplication("application/x-lim-plugin") {}
	
	virtual	void	AboutRequested();
};

class ConfigWindow :
	public BWindow
{
public:
								ConfigWindow(
									BRect			area,
									const char *	title,
									window_type		kind,
									uint32			flags);
		bool					QuitRequested();
};



ConfigWindow::ConfigWindow(
	BRect			area,
	const char *	title,
	window_type		kind,
	uint32			flags) :
	BWindow(area, title, kind, flags)
{
}


bool
ConfigWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;	/*	we will die!		*/
}


void ConfigApp::AboutRequested()
{
	BAlert* alert = new BAlert("About", addonInfo, "OK");
	alert->Go();
}


int
main()
{
	char str[256];
	
	srand(real_time_clock());
	
	sprintf(str, addonVersion % 10 ? "%s %d.%d.%d Defaults" : "%s %d.%d Defaults",
			addonName, addonVersion / 100, (addonVersion % 100) / 10, addonVersion % 10);
	ConfigApp app;
	ConfigWindow *window = new ConfigWindow(BRect(100,100,400,300), 
		str, B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE);
	BView *config = NULL;
	BRect extent(0,0,300,200);
	BMessage msg;
	msg.AddPointer("preview_invoker", NULL);
	status_t err = MakeConfig(&msg, &config);
	if ((err < B_OK) || (config == NULL))
	{
		BAlert *alrt = new BAlert("No Config", "This handler does not currently support user configuration.", "Quit");
		alrt->Go();
		exit(1);
	}
	extent = config->Bounds();
	extent.InsetBy(-10, -10);
	BMenuBar* menubar = new BMenuBar(window->Bounds(), "menubar");
	BMenu* menu = new BMenu("File");
	BMenuItem* item;
	menu->AddItem(item = new BMenuItem("About…", new BMessage(B_ABOUT_REQUESTED)));
	item->SetTarget(&app);
	
	menu->AddItem(new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED)));
	menubar->AddItem(menu);
	window->AddChild(menubar);
	menubar->ResizeToPreferred();
	window->ResizeTo(extent.Width(), extent.Height() + menubar->Bounds().Height());
	extent.OffsetTo(0, menubar->Bounds().bottom);
	BView* v = new BView(extent, NULL, B_WILL_DRAW, B_FOLLOW_ALL);
	v->SetViewColor(config->ViewColor());
	window->AddChild(v);
	v->AddChild(config);
	config->MoveTo(10, 10);
	window->Show();
	app.Run();
	SavePrefs();

	return 0;
}
